;nyquist plug-in
;version 4
;type analyze
;name "Max Min Peaks"
;author "Steve Daulton"
;release 2.4.2
;copyright "GPL v2+"

(defun peak-db (sig)
  (let ((ln (truncate len)))
    (setf max-peak (peak (s-max 0 sig) ln))
    (setf min-peak (peak (s-min 0 sig) ln))
    (setf sig nil)
    (list (linear-to-db max-peak) (linear-to-db min-peak))))


(defun main()
  (if (arrayp *track*)
      (let ((left (peak-db (aref *track* 0)))
            (right (peak-db (aref *track* 1))))
        (format nil
                "Left: Max ~a dB  Min ~a dB~%Right: Max ~a dB  Min ~a dB"
                (first left)
                (second left)
                (first right)
                (second right)))
      (let ((mono (peak-db *track*)))
        (format nil
                "Mono: Max ~ad B  Min ~a dB"
                (first mono)
                (second mono)))))

(setf *float-format* "%.2f")
(if (> len 100000000)
    (print "Selection must be less than 100 million samples.")
    (main))
